Code to compare random task graph generation methods
====================================================

Content
-------

Each R script at the root correspond to figures of the report entitled
"A Comparison of Random Task Graph Generation Methods for Scheduling
Problems".

Additional functions are in the directory `scripts/` (with one python
script).

Intermediate data are in `data/` and can be used by uncommenting lines
containing the call to the function `read_rds()`.

The final plots are in `plots/`.

Installation
------------

Even though it is possible to run this code on other systems with some
adjustments, the code was primarily developed on a debian-like system
(Ubuntu 18.04).

R scripts were used with the following packages on R 3.4.4:

- dplyr  0.8.0
- ggplot2 3.1.0
- igraph 1.2.4
- purrr 0.3.0
- Rcpp 1.0.0 (with g++ 7.3.0)
- readr 1.3.1
- rPython 0.0-6 (with Python 2.7.15rc1)
- tidyr 0.8.2
- tikzDevice 0.12

A recent version of R can be installed as follows on a debian-like
system (in a shell):

    $ sudo apt install r-base

The dependencies can be installed as follows on a debian-like system:

    $ sudo apt install g++
    $ sudo apt install python python-mpmath

Install all required packages as follows (around 10 minutes) within R
(launched with `R` in a shell):

    $ R
    > install.packages(c("dplyr" , "ggplot2", "igraph", "purrr", "Rcpp",
                         "readr", "rPython", "tidyr", "tikzDevice"))

Generating figures (around 30 minutes)
--------------------------------------

Each script at the root can be launched as follows to generate all the
plots for the research report (in a shell):

    $ Rscript ./1_special_schedule.R         # ~1 minute
    $ Rscript ./2_erdos_analysis.R           # ~1 minute
    $ Rscript ./3_recursive_analysis.R       # ~5 minutes
    $ Rscript ./4_poset_analysis.R           # ~1 minute
    $ Rscript ./5_layer_analysis.R           # ~1 minute
    $ Rscript ./6_heuristics_comparison.R    # ~15 minutes
