DAG_empty <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  adj_mat
}

DAG_complete <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  for (i in seq_len(n - 1))
    for (j in (i + 1):n)
      adj_mat[i,j] <- 1
  adj_mat
}

DAG_outtree <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  for (i in 2:n) {
    pred <- i %/% 2
    if (pred >= 1)
      adj_mat[pred,i] <- 1
  }
  adj_mat
}

DAG_comb <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  half <- (n - 1) %/% 2
  for (i in seq_len(half)) {
    adj_mat[i,i + 1] <- 1
    adj_mat[i,i + half + 1] <- 1
  }
  adj_mat
}

DAG_bipartite <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  half <- n %/% 2
  for (i in seq_len(half))
    for (j in (half + 1):n)
      adj_mat[i,j] <- 1
  adj_mat
}

DAG_square <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  level <- as.integer(sqrt(n - 1)) + 1
  for (l in seq_len(level - 1)) {
    offset <- (l - 1) * level
    for (i in seq_len(level))
      for (j in seq_len(level))
        if (offset + level + j <= n)
          adj_mat[offset + i, offset + level + j] <- 1
  }
  adj_mat
}

DAG_triangular <- function(n) {
  adj_mat <- matrix(0, nrow = n, ncol = n)
  level <- 1
  while (TRUE) {
    offset <- level * (level - 1) / 2
    if (offset >= n)
      break
    for (i in seq_len(level))
      for (j in seq_len(level + 1))
        if (offset + level + j <= n)
          adj_mat[offset + i, offset + level + j] <- 1
    level <- level + 1
  }
  adj_mat
}
